import { DataClass } from "data-class-copy";
import "ts-instance-of";
import { Handler } from "./handler";
import { Route } from "./route";
import { Router } from "./router";
export interface EndPointParams {
    path: string;
    method: string;
}
export interface EndPoint extends EndPointParams, DataClass<EndPointParams> {
}
export declare class EndPoint {
    static empty: EndPoint;
    static fromHandler(handler: Handler): EndPoint;
    static fromRouter(router: Router): EndPoint;
    static flatRoute(route: Route): EndPoint[];
    constructor(params: EndPointParams);
}
