"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var data_class_copy_1 = require("data-class-copy");
require("ts-instance-of");
var handler_1 = require("./handler");
var flatMap = require("lodash/flatMap");
var EndPoint = (function () {
    function EndPoint(params) {
        Object.assign(this, params);
    }
    EndPoint_1 = EndPoint;
    EndPoint.fromHandler = function (handler) {
        return EndPoint_1.empty.copy({
            method: handler.method,
            path: handler.fullPath
        });
    };
    EndPoint.fromRouter = function (router) {
        return EndPoint_1.empty.copy({
            path: router.fullPath
        });
    };
    EndPoint.flatRoute = function (route) {
        if (handler_1.Handler.isInstanceOf(route)) {
            return [EndPoint_1.fromHandler(route)];
        }
        if (route.routes.length === 0) {
            return [EndPoint_1.fromRouter(route)];
        }
        return flatMap(route.routes, EndPoint_1.flatRoute);
    };
    var EndPoint_1;
    EndPoint.empty = new EndPoint_1({
        path: "",
        method: "GET"
    });
    EndPoint = EndPoint_1 = tslib_1.__decorate([
        data_class_copy_1.dataClass
    ], EndPoint);
    return EndPoint;
}());
exports.EndPoint = EndPoint;
//# sourceMappingURL=endPoint.js.map