export interface ExpressHandler {
    path: string;
    method: string;
}
export interface ExpressRouter {
    name: string;
    path: string;
    regexp: RegExp;
    handle?: {
        stack: ExpressRoute[] | null;
        name: string;
        path: string;
    };
    route?: {
        stack: ExpressRoute[] | null;
        name: string;
        path: string;
    };
}
export declare type ExpressRoute = ExpressHandler | ExpressRouter;
export interface ExpressApp {
    _router: {
        stack: ExpressRoute[];
    };
}
export declare function isExpressRouter(e: ExpressRoute): e is ExpressRouter;
export declare function isExpressHandler(e: ExpressRoute): e is ExpressHandler;
