import { DataClass } from "data-class-copy";
import { ExpressHandler } from "./express";
import { Router } from "./router";
export interface HandlerParams {
    path: string;
    method: string;
    expressHandler: ExpressHandler | null;
    router?: Router;
}
export interface Handler extends HandlerParams, DataClass<HandlerParams> {
}
export declare class Handler {
    static empty: Handler;
    static parseExpressHandler(expressHandler: ExpressHandler): Handler;
    constructor(params: HandlerParams);
    readonly fullPath: string;
}
