import { DataClass } from "data-class-copy";
import { EndPoint } from "./endPoint";
import { ExpressApp, ExpressRouter } from "./express";
import { Route } from "./route";
export interface RouterParams {
    path: string;
    routes: Route[];
    expressRouter: ExpressRouter | null;
    router?: Router;
}
export interface Router extends RouterParams, DataClass<RouterParams> {
}
export declare class Router {
    static empty: Router;
    static parseExpressRouter(expressRouter: ExpressRouter): Router;
    static parseExpressApp(app: ExpressApp): Router;
    constructor(params: RouterParams);
    readonly children: Route[];
    setParentOnChildren(): this;
    readonly fullPath: string;
    readonly toEndPoints: EndPoint[];
}
