"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var util_1 = require("util");
var route_1 = require("./route");
var services = {
    writeFile: util_1.promisify(fs.writeFile)
};
function typeGenerator(app, methods) {
    if (methods === void 0) { methods = ["Get", "Post", "Put", "Delete", ""]; }
    var routes = route_1.parseExpressApp(app).setParentOnChildren();
    function asString() {
        return methods.map(function (method) {
            var paths = routes.toEndPoints.filter(function (ep) { return ep.method.toLowerCase() === method.toLowerCase(); })
                .map(function (ep) { return "\"" + ep.path + "\""; })
                .join(" |\n");
            return paths.length ? "export type " + method + "Path = " + paths : "";
        }).join("\n\n");
    }
    function toFile(path) {
        var str = asString();
        return services.writeFile(path, str);
    }
    return {
        asString: asString,
        toFile: toFile
    };
}
exports.typeGenerator = typeGenerator;
//# sourceMappingURL=typeGenerator.js.map